/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.gpdv.core.api;

import org.gpdv.core.api.designgraph.DesignGraph;
import org.gpdv.core.api.layoutgraph.LayoutGraph;

/**
 *
 * @author odi
 */
public final class LayoutGraphFactory {

    private static LayoutGraphFactory instance;

    private LayoutGraphFactory(){
    }

    public static synchronized LayoutGraphFactory getFactory(){
        if(instance==null) instance = new LayoutGraphFactory();
        return instance;
    }

    public LayoutGraph createLayoutGraph(DesignGraph graph){
        return graph;
    }
}
