/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.gpdv.core.api.abstractgraph;

import java.beans.PropertyChangeListener;
import java.util.Map;
import java.util.Set;

/**
 *
 * @author odi
 */
public interface GraphPropertyProvider {
    public Map<String, String> getProperties();
    public void addProperty(String key, String value);
    public void removeProperty(String key);
    public void setProperties(Map<String, String> properties);
    public String getValue(String key);
    public Set<String> getKeys();
    public void addPropertyChangeListener(PropertyChangeListener listener);
    public void removePropertyChangeListener(PropertyChangeListener listener);
}
