/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.gpdv.core.api.designgraph;

import java.util.EventObject;
import java.util.List;

/**
 *
 * @author odi
 */
public class DesignGraphSlotChangeEvent extends EventObject{
    public static final String EDGE_ADDED = "EDGE_ADDED";
    public static final String EDGE_REMOVED = "EDGE_REMOVED";
    public static final String NEW_DESIGN = "NEW_DESIGN";

    private DesignGraphSlot slot;
    private String changeString;
    private DesignGraphEdge edge;
    private Design design;

    public DesignGraphSlotChangeEvent(DesignGraphSlot slot, String changeString, DesignGraphEdge edge, Design design){
        super(slot);
        this.slot = slot;
        this.changeString = changeString;
        this.edge = edge;
        this.design = design;
    }

    public DesignGraphSlot getSlot(){
        return slot;
    }

    public String getChangeString(){
        return changeString;
    }

    public DesignGraphEdge getChangedEdge(){
        return edge;
    }

    public Design getOldDesign(){
        return design;
    }
}
