/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.gpdv.core.api.layoutgraph;

import java.awt.Point;
import java.util.EventObject;
import java.util.List;

/**
 *
 * @author odi
 */
public class LayoutGraphNodeChangeEvent extends EventObject{
    public static final String INCOMING_SLOT_ADDED = "INCOMING_SLOT_ADDED";
    public static final String INCOMING_SLOT_REMOVED = "INCOMING_SLOT_REMOVED";
    public static final String OUTGOING_SLOT_ADDED = "OUTGOING_SLOT_ADDED";
    public static final String OUTGOING_SLOT_REMOVED = "OUTGOING_SLOT_REMOVED";
    public static final String NEW_POINT = "NEW_POINT";

    private LayoutGraphNode node;
    private String changeString;
    private LayoutGraphSlot slot;
    private Point point;
    
    public LayoutGraphNodeChangeEvent(LayoutGraphNode node, String changeString, LayoutGraphSlot slot, Point p){
        super(node);
        this.node = node;
        this.changeString = changeString;
        this.slot = slot;
        this.point = p;
    }
    
    public LayoutGraphNode getNode(){
        return node;
    }

    public String getChangeString(){
        return changeString;
    }

    public LayoutGraphSlot getChangedSlot(){
        return slot;
    }

    public Point getOldPoint(){
        return point;
    }
}
