/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.gpdv.core.api.views;

import java.awt.BorderLayout;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.beans.PropertyVetoException;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Logger;
import javax.swing.JScrollPane;
import org.gpdv.core.api.GraphView;
import org.gpdv.core.implementation.views.VisualizationManagementPanel;
import org.openide.util.Exceptions;
import org.openide.util.LookupEvent;
import org.openide.util.NbBundle;
import org.openide.windows.TopComponent;
import org.openide.windows.WindowManager;
//import org.openide.util.ImageUtilities;
import org.netbeans.api.settings.ConvertAsProperties;
import org.netbeans.spi.navigator.NavigatorLookupHint;
import org.openide.actions.CopyAction;
import org.openide.actions.CutAction;
import org.openide.actions.DeleteAction;
import org.openide.actions.PasteAction;
import org.openide.explorer.ExplorerManager;
import org.openide.explorer.ExplorerUtils;
import org.openide.explorer.view.BeanTreeView;
import org.openide.nodes.AbstractNode;
import org.openide.nodes.Children;
import org.openide.nodes.Node;
import org.openide.util.Lookup;
import org.openide.util.LookupListener;
import org.openide.util.Utilities;
import org.openide.util.actions.SystemAction;
import org.openide.util.lookup.AbstractLookup;
import org.openide.util.lookup.InstanceContent;
import org.openide.util.lookup.ProxyLookup;
import org.openide.windows.IOProvider;
import org.openide.windows.Mode;
import org.openide.windows.OutputWriter;

/**
 * Top component which displays a graph selected by another TopComponent and it's selected nodes.
 */
@ConvertAsProperties(
    dtd="-//org.gpdv.core.api.views//GraphExplorer//EN",
    autostore=false
)
public final class GraphExplorerTopComponent extends TopComponent implements ExplorerManager.Provider, LookupListener{

    // NOT UP-TO-DATE!!!
    // WILL BE MOVED FROM API TO IMPLEMENTATION PACKAGE
    // WILL BE REWRITTEN TO BE ATTACHED DIRECTLY TO ACTIVE VISUALIZATIONTOPCOMPONENT
    // SO THAT EXPLORERVIEW USES AN MANIPULATES VISUALIZATIONTOPCOMPONENT'S EXPLORERMANAGER
    // BUGGY WHEN CHANGING TO OTHER TOPCOMPONENT...

    private ExplorerManager manager;
    private ExplorerManager tcManager;
    private TopComponent.Registry registry;
    private PropertyChangeListener listenerOnManager;
    private PropertyChangeListener listenerOnTcManager;
    private AbstractLookup abstractLookup;
    private InstanceContent content;
    private Lookup.Result<Object> graphViews;

    private JScrollPane jScrollPane1;

    private static GraphExplorerTopComponent instance;
    /** path to the icon used by the component and its open action */
//    static final String ICON_PATH = "SET/PATH/TO/ICON/HERE";

    private static final String PREFERRED_ID = "GraphExplorerTopComponent";

    public ExplorerManager getExplorerManager() {
        return manager;
    }

//////////    public void propertyChange(PropertyChangeEvent evt) {
//////////        if(!evt.getPropertyName().equals(TopComponent.Registry.PROP_ACTIVATED)) return;
////////////        io.println("TC CHANGED"+i++);
////////////        if(registry.getActivated()==null) return;
////////////        io.println(registry.getActivated().toString());
//////////        VisualizationManagementPanel p = (VisualizationManagementPanel) Utilities.actionsGlobalContext().lookup(GraphView.class);
//////////        System.out.println("GRAPHEXPLORER!!!");
//////////        System.out.println(p);
//////////        if(p!=null){
//////////            setManager(p);
//////////        }
//////////        return;
////////////        TopComponent tc = registry.getActivated();
////////////        if(tc instanceof VisualizationTopComponent){
////////////            setManager((VisualizationTopComponent)tc);
////////////        } else {
////////////            VisualizationManagementPanel p = (VisualizationManagementPanel) Utilities.actionsGlobalContext().lookup(GraphView.class);
////////////            if(p!=null){
////////////                setManager(p);
////////////            }
////////////        }
//////////    }

    public GraphExplorerTopComponent() {
        initComponents();
        setName(NbBundle.getMessage(GraphExplorerTopComponent.class, "CTL_GraphExplorerTopComponent"));
        setToolTipText(NbBundle.getMessage(GraphExplorerTopComponent.class, "HINT_GraphExplorerTopComponent"));
        manager = new ExplorerManager();
        manager.setRootContext(new AbstractNode(Children.LEAF));
        registry = TopComponent.getRegistry();
//        manager.addPropertyChangeListener(this);
        jScrollPane1 = new BeanTreeView();
        content = new InstanceContent();
        content.add(new Hint());
        abstractLookup = new AbstractLookup(content);
        graphViews = Utilities.actionsGlobalContext().lookupResult(Object.class);
        setLayout(new BorderLayout());
        add(jScrollPane1, BorderLayout.CENTER);
        initActions();
        associateLookup(new ProxyLookup(abstractLookup, ExplorerUtils.createLookup(manager, getActionMap())));
//        setIcon(ImageUtilities.loadImage(ICON_PATH, true));

    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 400, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 300, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents

    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables
    /**
     * Gets default instance. Do not use directly: reserved for *.settings files only,
     * i.e. deserialization routines; otherwise you could get a non-deserialized instance.
     * To obtain the singleton instance, use {@link #findInstance}.
     */
    public static synchronized GraphExplorerTopComponent getDefault() {
        if (instance == null) {
            instance = new GraphExplorerTopComponent();
        }
        return instance;
    }

    /**
     * Obtain the GraphExplorerTopComponent instance. Never call {@link #getDefault} directly!
     */
    public static synchronized GraphExplorerTopComponent findInstance() {
        TopComponent win = WindowManager.getDefault().findTopComponent(PREFERRED_ID);
        if (win == null) {
            Logger.getLogger(GraphExplorerTopComponent.class.getName()).warning(
                    "Cannot find " + PREFERRED_ID + " component. It will not be located properly in the window system.");
            return getDefault();
        }
        if (win instanceof GraphExplorerTopComponent) {
            return (GraphExplorerTopComponent) win;
        }
        Logger.getLogger(GraphExplorerTopComponent.class.getName()).warning(
                "There seem to be multiple components with the '" + PREFERRED_ID +
                "' ID. That is a potential source of errors and unexpected behavior.");
        return getDefault();
    }

    @Override
    public int getPersistenceType() {
        return TopComponent.PERSISTENCE_ALWAYS;
    }

    @Override
    public void componentOpened() {
        // TODO add custom code on component opening
//        registry.addPropertyChangeListener(this);
        graphViews.addLookupListener(this);
        graphViews.allInstances();
    }

    @Override
    public void componentClosed() {
        // TODO add custom code on component closing
//        registry.removePropertyChangeListener(this);
        graphViews.removeLookupListener(this);
    }

    void writeProperties(java.util.Properties p) {
        // better to version settings since initial version as advocated at
        // http://wiki.apidesign.org/wiki/PropertyFiles
        p.setProperty("version", "1.0");
        // TODO store your settings
    }

    Object readProperties(java.util.Properties p) {
        GraphExplorerTopComponent singleton = GraphExplorerTopComponent.getDefault();
        singleton.readPropertiesImpl(p);
        return singleton;
    }

    private void readPropertiesImpl(java.util.Properties p) {
        String version = p.getProperty("version");
        // TODO read your settings according to their version
    }

    @Override
    protected String preferredID() {
        return PREFERRED_ID;
    }

    private void initActions() {
        CutAction cut = SystemAction.get(CutAction.class);
        getActionMap().put(cut.getActionMapKey(), ExplorerUtils.actionCut(manager));

        CopyAction copy = SystemAction.get(CopyAction.class);
        getActionMap().put(copy.getActionMapKey(), ExplorerUtils.actionCopy(manager));

        PasteAction paste = SystemAction.get(PasteAction.class);
        getActionMap().put(paste.getActionMapKey(), ExplorerUtils.actionPaste(manager));

        DeleteAction delete = SystemAction.get(DeleteAction.class);
        getActionMap().put(delete.getActionMapKey(), ExplorerUtils.actionDelete(manager, true));
    }

    @Override
    public void componentActivated(){
        ExplorerUtils.activateActions(manager, true);
    }

    @Override
    public void componentDeactivated(){
        ExplorerUtils.activateActions(manager, false);
    }

////////////    private void setManager(VisualizationTopComponent tc) {
//////////////        io.println("NEW TOPCOMPONENT IS VTC!");
//////////////        io.println("TC MANAGER: "+tc.getExplorerManager().toString());
////////////        if(this.tcManager==tc.getExplorerManager()) return;
//////////////        this.manager.removePropertyChangeListener(this);
////////////        if(listenerOnManager!=null&&listenerOnTcManager!=null){
////////////            manager.removePropertyChangeListener(listenerOnManager);
////////////            tcManager.removePropertyChangeListener(listenerOnTcManager);
////////////        }
////////////        tcManager = tc.getExplorerManager();
////////////        this.manager.setRootContext(tcManager.getRootContext());
////////////        try {
////////////            this.manager.setSelectedNodes(tcManager.getSelectedNodes());
////////////        } catch (PropertyVetoException ex) {
////////////            Exceptions.printStackTrace(ex);
////////////        }
////////////        listenerOnManager = new PropertyChangeListenerImpl(tcManager, manager, true);
////////////        listenerOnTcManager = new PropertyChangeListenerImpl(manager, tcManager, true);
////////////        this.manager.addPropertyChangeListener(listenerOnManager);
////////////        tcManager.addPropertyChangeListener(listenerOnTcManager);
////////////        GraphView gv = abstractLookup.lookup(GraphView.class);
////////////        if(gv!=null) content.remove(gv);
////////////        gv = tc.getLookup().lookup(GraphView.class);
////////////        if(gv!=null) content.add(gv);
////////////    }

    private void setManager(VisualizationManagementPanel tc) {
        if(listenerOnManager!=null&&listenerOnTcManager!=null){
            manager.removePropertyChangeListener(listenerOnManager);
            tcManager.removePropertyChangeListener(listenerOnTcManager);
        }
        tcManager = tc.getExplorerManager();
        this.manager.setRootContext(tcManager.getRootContext());
//        System.out.println(manager.getRootContext());
        try {
            this.manager.setSelectedNodes(tcManager.getSelectedNodes());
        } catch (PropertyVetoException ex) {
            Exceptions.printStackTrace(ex);
        }
        listenerOnManager = new PropertyChangeListenerImpl(tcManager, manager, true);
        listenerOnTcManager = new PropertyChangeListenerImpl(manager, tcManager, true);
        this.manager.addPropertyChangeListener(listenerOnManager);
        tcManager.addPropertyChangeListener(listenerOnTcManager);
        GraphView gv = abstractLookup.lookup(GraphView.class);
        if(gv!=null) content.remove(gv);
        gv = tc.getLookup().lookup(GraphView.class);
        if(gv!=null) content.add(gv);
    }

    public void resultChanged(LookupEvent ev) {
//        System.out.println("LOOKUP RESULT CHANGED!!!");
        if(registry.getActivated()==this) return;
        VisualizationManagementPanel p = Utilities.actionsGlobalContext().lookup(VisualizationManagementPanel.class);
        if(p!=null){
            setManager(p);
        }
    }

    private class PropertyChangeListenerImpl implements PropertyChangeListener{

        private boolean onlySelectedNodes;
        private ExplorerManager emChange;
        private ExplorerManager emListen;
        public PropertyChangeListenerImpl(ExplorerManager emToChange, ExplorerManager emToListen, boolean onlySelectedNodes){
            this.emChange = emToChange;
            this.emListen = emToListen;
            this.onlySelectedNodes = onlySelectedNodes;
        }
        public void propertyChange(PropertyChangeEvent evt) {
            if(!onlySelectedNodes) emChange.setRootContext(emListen.getRootContext());
            try {
                emChange.setSelectedNodes(emListen.getSelectedNodes());
            } catch (PropertyVetoException ex) {
                Exceptions.printStackTrace(ex);
            }
        }
    }

    private class Hint implements NavigatorLookupHint{

        public String getContentType() {
            return "gpdvgraph";
        }

    }
}
