/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.gpdv.core.implementation.actions;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import org.gpdv.core.api.abstractgraph.AbstractGraphNode;
import org.openide.util.ContextAwareAction;
import org.openide.util.Lookup;
import org.openide.util.NbBundle;
import org.openide.util.Utilities;
import org.openide.util.actions.Presenter;

public final class RemoveNodeAction extends AbstractAction implements ContextAwareAction {

    private Lookup context;

    public RemoveNodeAction(){
        this(Utilities.actionsGlobalContext());
    }

    private RemoveNodeAction(Lookup context){
//        putValue (NAME, "Remove Node");
        putValue(Action.NAME, NbBundle.getMessage(RemoveNodeAction.class, "CTL_RemoveNodeAction"));
        this.context = context;
    }

    public void actionPerformed(ActionEvent e) {
        // TODO implement action body
        AbstractGraphNode n = context.lookup(AbstractGraphNode.class);
        if(n!=null){
            n.getGraph().removeNode(n);
        }
    }
//    public void actionPerformed(ActionEvent e) {
//        // TODO implement action body
//        Object o = e.getSource();
//        System.out.println("ACTION PERFORMED");
//        if(o instanceof JMenuItem){
//            JMenuItem i = (JMenuItem)o;
//            AbstractGraphNode n = (AbstractGraphNode) i.getClientProperty("node");
//            System.out.println("ABSTRACTNODE :" + n.getName());
//            n.getGraph().removeNode(n);
//        }
//    }

    public Action createContextAwareInstance(Lookup actionContext) {
        return new RemoveNodeAction(actionContext);
    }

//    public JMenuItem getPopupPresenter() {
//        JMenu menu = new JMenu(NbBundle.getMessage(RemoveNodeAction.class, "CTL_RemoveNodeAction"));
//        AbstractGraphNode n = context.lookup(AbstractGraphNode.class);
//        for(AbstractGraphNode node : n.getGraph().getNodes()){
//            if(node!=n){
//                JMenuItem item = new JMenuItem(this);
//                item.setText(node.getName());
//                item.putClientProperty("node", node);
//                menu.add(item);
//            }
//        }
//        return menu;
//    }
}
