/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.gpdv.core.implementation.nodes;

import java.util.ArrayList;
import java.util.List;
import org.gpdv.core.api.designgraph.DesignGraph;
import org.openide.nodes.Children;
import org.openide.nodes.Node;

/**
 *
 * @author odi
 */
public final class GraphChildren extends Children.Keys<DesignGraph>{

    private DesignGraph graph;

    public GraphChildren(DesignGraph graph) {
        this.graph = graph;
    }

    @Override
    protected void addNotify() {
        super.addNotify();
        List<DesignGraph> keys = new ArrayList<DesignGraph>();
        keys.add(graph);
        setKeys(keys);
    }

    @Override
    protected Node[] createNodes(DesignGraph key) {
        return new Node[]{new NodeListNode(graph), new EdgeListNode(graph)};
    }
}
