/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.gpdv.core.implementation.scenes;

import java.awt.Point;
import java.util.ArrayList;
import java.util.List;
import org.gpdv.services.GraphRouter;
import org.netbeans.api.visual.widget.ConnectionWidget;
import org.netbeans.api.visual.widget.LayerWidget;
import org.openide.nodes.AbstractNode;
import org.openide.nodes.Children;
import org.openide.nodes.Node;

/**
 *
 * @author odi
 */
public class TestRouter2 implements GraphRouter{

    private final String NAME = "HORIZONTALSTARTROUTER";
    private final String DISPLAYNAME = "Horizontal start router";
    private final String DESCRIPTION = "Router that starts all connections in horizontal direction";

    @Override
    public Node getRepresentation(){
        AbstractNode n = new AbstractNode(Children.LEAF);
        n.setName(NAME);
        n.setDisplayName(DISPLAYNAME);
        n.setShortDescription(DESCRIPTION);
        return n;
    }

    public void setLayerWidget(LayerWidget widget){

    }

    public List<Point> routeConnection(ConnectionWidget widget) {
        Point start = widget.getSourceAnchor().compute(widget.getSourceAnchorEntry()).getAnchorSceneLocation();
        Point end = widget.getTargetAnchor().compute(widget.getTargetAnchorEntry()).getAnchorSceneLocation();
        List<Point> p = new ArrayList<Point>();
        p.add(start);
        Point p1;
        if(start.x<end.x){
            p1 = new Point(Math.min(start.x+30, end.x), start.y);
            p.add(p1);
        } else {
            p1 = new Point(Math.max(start.x-30, end.x), start.y);
            p.add(p1);
        }
        p.add(end);
        return p;
    }

}
