/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

import java.util.Collection;
import java.util.Set;
import org.gpdv.services.GraphBuilder;
import org.gpdv.services.modulegraphbuilder.ModuleGraphBuilderImpl;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import org.openide.modules.Dependency;
import org.openide.modules.ModuleInfo;
import org.openide.util.Lookup;
import static org.junit.Assert.*;

/**
 *
 * @author odi
 */
public class ModuleTest {

    public ModuleTest() {
    }

    @BeforeClass
    public static void setUpClass() throws Exception {
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }

    @Before
    public void setUp() {
    }

    @After
    public void tearDown() {
    }

     @Test
     public void testModule() {
         GraphBuilder gb = new ModuleGraphBuilderImpl();
         Collection<? extends ModuleInfo> infos = Lookup.getDefault().lookupAll(ModuleInfo.class);
         ModuleInfo mainModule = null;
         for(ModuleInfo i : infos){
             if(i.getDisplayName().equals("General Purpose Dependency Viewer - Core")){
                 mainModule = i;
                 System.out.println(i.getCodeNameBase());
                 break;
             }
         }
         System.out.println("Dependencies: ");
         Set<Dependency> deps = mainModule.getDependencies();
         for(Dependency d : deps){
//             System.out.println("Depenency Name: " + d.getName());
             ModuleInfo curMod = null;
             for(ModuleInfo i : infos){
                 if(i.getCodeNameBase().equals(d.getName())){
                     curMod = i;
                     break;
                 }
             }
             if(curMod!=null){
                 System.out.println(curMod.getCodeNameBase());
             } else {
                 System.out.println(d.getName() + " No ModuleInfo found!");
             }
         }
     }

}