/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.gpdv.core.api.layoutgraph;

import java.util.List;
import org.gpdv.core.api.designgraph.DesignGraphEdge;
import org.gpdv.core.api.designgraph.DesignGraph;
import org.gpdv.core.api.designgraph.DesignGraphNode;

/**
 *
 * @author odi
 */
public interface LayoutGraph {
    public DesignGraph getDesignGraph();
    public String getName();
    public long getID();
    public List<LayoutGraphNode> getLayoutNodes();
    public List<LayoutGraphEdge> getLayoutEdges();
//    public LayoutGraphNode findNode(DesignGraphNode node);
//    public LayoutGraphEdge findEdge(DesignGraphEdge edge);
    public void addLayoutGraphChangeListener(LayoutGraphChangeListener listener);
    public void removeLayoutGraphChangeListener(LayoutGraphChangeListener listener);
}
