/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.gpdv.core.api.layoutgraph;

import java.awt.Point;
import java.util.List;
import org.gpdv.core.api.designgraph.DesignGraphEdge;

/**
 *
 * @author odi
 */
public interface LayoutGraphEdge {
    public LayoutGraph getLayoutGraph();
    public String getName();
    public long getID();
    public DesignGraphEdge getDesignEdge();
//    public LayoutNode getSourceLayoutNode();
//    public LayoutNode getDestinationLayoutNode();
    public LayoutGraphSlot getSourceLayoutSlot();
    public LayoutGraphSlot getDestinationLayoutSlot();
    public boolean addControlPoint(Point p);
    public boolean removeControlPoint(Point p);
    public boolean removeControlPointByCoords(Point p);
//    public void setControlPoints(Set<Layout> points);
    public List<Point> getControlPoints();
    public void addLayoutGraphEdgeChangeListener(LayoutGraphEdgeChangeListener listener);
    public void removeLayoutGraphEdgeChangeListener(LayoutGraphEdgeChangeListener listener);
}
