/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.gpdv.core.api.layoutgraph;

import java.awt.Point;
import java.util.EventObject;
import java.util.List;

/**
 *
 * @author odi
 */
public class LayoutGraphEdgeChangeEvent extends EventObject{
    public static final String NEW_SOURCE = "NEW_SOURCE";
    public static final String NEW_DESTINATION = "NEW_DESTINATION";
    public static final String CONTROL_POINT_ADDED = "CONTROL_POINT_ADDED";
    public static final String CONTROL_POINT_REMOVED = "CONTROL_POINT_REMOVED";

    private LayoutGraphEdge edge;
    private String changeString;
    private LayoutGraphSlot slot;
    private Point point;

    public LayoutGraphEdgeChangeEvent(LayoutGraphEdge edge, String changeString, LayoutGraphSlot slot, Point point){
        super(edge);
        this.edge = edge;
        this.changeString = changeString;
        this.slot = slot;
        this.point = point;
    }

    public String getChangeString(){
        return changeString;
    }

    public LayoutGraphEdge getEdge(){
        return edge;
    }

    public LayoutGraphSlot getOldSlot(){
        return slot;
    }

    public Point getChangedPoint(){
        return point;
    }
}
