/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.gpdv.core.api.layoutgraph;

import java.awt.Point;
import java.util.List;
import org.gpdv.core.api.designgraph.DesignGraphNode;

/**
 *
 * @author odi
 */
public interface LayoutGraphNode {
    public LayoutGraph getLayoutGraph();
    public String getName();
    public long getID();
    public DesignGraphNode getDesignNode();
    public List<LayoutGraphSlot> getIncomingLayoutSlots();
    public List<LayoutGraphSlot> getOutgoingLayoutSlots();
    public Point getPoint();
    public boolean setPoint(Point p);
    public int getWidth();
    public int getHeight();
//    public List<LayoutEdge> getIncomingLayoutEdges();
//    public List<LayoutEdge> getOutgoingLayoutEdges();
//    public List<LayoutGraphNode> getSuccessorLayoutNodes();
//    public List<LayoutGraphNode> getPredecessorLayoutNodes();
    public void addLayoutGraphNodeChangeListener(LayoutGraphNodeChangeListener listener);
    public void removeLayoutGraphNodeChangeListener(LayoutGraphNodeChangeListener listener);
}
