/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.gpdv.core.api.layoutgraph;

import java.awt.Point;
import java.util.EventObject;
import java.util.List;

/**
 *
 * @author odi
 */
public class LayoutGraphSlotChangeEvent extends EventObject{
    public static final String EDGE_ADDED = "EDGE_ADDED";
    public static final String EDGE_REMOVED = "EDGE_REMOVED";
    public static final String NEW_POINT = "NEW_POINT";

    private LayoutGraphSlot slot;
    private String changeString;
    private LayoutGraphEdge edge;
    private Point point;

    public LayoutGraphSlotChangeEvent(LayoutGraphSlot slot, String changeString, LayoutGraphEdge edge, Point point){
        super(slot);
        this.slot = slot;
        this.changeString = changeString;
        this.edge = edge;
        this.point = point;
    }

    public LayoutGraphSlot getSlot(){
        return slot;
    }

    public String getChangeString(){
        return changeString;
    }

    public LayoutGraphEdge getChangedEdge(){
        return edge;
    }

    public Point getOldPoint(){
        return point;
    }
}
