/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.gpdv.core.implementation.globalactions;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.util.ArrayList;
import java.util.Collection;
import org.gpdv.services.GraphBuilder;
import org.gpdv.core.api.abstractgraph.AbstractGraph;
import org.gpdv.core.api.Visualizer;
import org.gpdv.services.GraphDesigner;
import org.openide.filesystems.FileObject;
import org.openide.loaders.DataObject;

public final class AntAction implements ActionListener {

    private final DataObject context;

    public AntAction(DataObject context) {
        this.context = context;
    }

    public void actionPerformed(ActionEvent ev) {
        if(context!=null){
            FileObject fo = context.getPrimaryFile();
            if(fo!=null){
                Collection<GraphBuilder> builders = Visualizer.Utils.getGraphBuildersForMimeType("text/x-ant+xml");
                System.out.println(builders.size());
                for(GraphBuilder b : builders){
                    if(b.accepts(fo)){
                        AbstractGraph g = b.buildGraph(fo);
                        if(g!=null){
                            Visualizer.getVisualizer().visualize(Visualizer.getVisualizer().getVisualizationRequest(g).setDesigners(new ArrayList<GraphDesigner>(Visualizer.Utils.getGraphDesignersForMimeType("java/class"))));
                        }
                        return;
                    }
                }
            }
        }
    }
}
