/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.gpdv.core.implementation.globalactions;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.util.ArrayList;
import java.util.Collection;
import org.gpdv.services.GraphBuilder;
import org.gpdv.core.api.abstractgraph.AbstractGraph;
import org.gpdv.core.api.Visualizer;
import org.gpdv.services.GraphDesigner;
import org.netbeans.api.project.Project;

public final class AntGlobalAction implements ActionListener {

    private final Project context;

    public AntGlobalAction(Project context) {
        this.context = context;
    }

    public void actionPerformed(ActionEvent ev) {
        if(context!=null){
            Collection<GraphBuilder> builders = Visualizer.Utils.getGraphBuildersForMimeType("text/x-ant+xml");
            for(GraphBuilder b : builders){
                if(b.accepts(context)){
                    AbstractGraph g = b.buildGraph(context);
                    if(g!=null){
                        Visualizer.getVisualizer().visualize(Visualizer.getVisualizer().getVisualizationRequest(g).setDesigners(new ArrayList<GraphDesigner>(Visualizer.Utils.getGraphDesignersForMimeType("java/class"))));
                    }
                }
            }
        }
    }
}
