/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.gpdv.core.implementation.nodes;

import java.awt.event.ActionEvent;
import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.Icon;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import org.openide.util.actions.Presenter;

/**
 *
 * @author odi
 */
public class ActionWrapper extends AbstractAction implements Presenter.Popup{
    private JMenu menu;

    public void addAction(Action action){
        if(action instanceof Presenter.Popup){
            Presenter.Popup p = (Presenter.Popup)action;
            JMenuItem item = p.getPopupPresenter();
            menu.add(item);
            return;
        }
        JMenuItem item = new JMenuItem(action);
        menu.add(item);
    }

    public ActionWrapper(String name){
        super.putValue(NAME, name);
        menu = new JMenu(name);
    }

    public void actionPerformed(ActionEvent e) {
        System.out.println("ActionWrapper PERFORMED");
    }

    public JMenuItem getPopupPresenter() {
        return menu;
    }

    public void setIcon(Icon icon){
        menu.setIcon(icon);
    }
}
