/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.gpdv.core.implementation.nodes;

import java.lang.reflect.InvocationTargetException;
import org.gpdv.core.api.abstractgraph.GraphPropertyProvider;
import org.openide.nodes.PropertySupport;

/**
 *
 * @author odi
 */
public final class PropertyImpl extends PropertySupport.ReadWrite<String> {

        GraphPropertyProvider provider;
        private String prop;
        private String value;
        PropertyImpl(GraphPropertyProvider provider, String prop, String value){
            super(prop, java.lang.String.class, prop, prop);
            this.provider = provider;
            this.value = value;
            this.prop = prop;
        }

        @Override
        public String getValue() throws IllegalAccessException, InvocationTargetException {
            return value;
        }

        @Override
        public void setValue(String arg0) throws IllegalAccessException, IllegalArgumentException, InvocationTargetException {
            provider.removeProperty(prop);
            provider.addProperty(prop, arg0);
        }
    }
