/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.gpdv.core.implementation.nodes;

import java.util.ArrayList;
import java.util.List;
import org.gpdv.core.api.designgraph.DesignGraphSlot;
import org.gpdv.core.api.designgraph.DesignGraphSlotChangeEvent;
import org.openide.nodes.Children;
import org.openide.nodes.Node;

/**
 *
 * @author odi
 */
class SlotListChildren extends Children.Keys<DesignGraphSlot>{

    private List<DesignGraphSlot> slots;

    public SlotListChildren(List<DesignGraphSlot> slotList) {
        this.slots = slotList;

    }

    @Override
    protected void addNotify(){
        super.addNotify();
        List<DesignGraphSlot> keys = new ArrayList<DesignGraphSlot>();
        for(DesignGraphSlot s : slots){
            keys.add(s);
        }
        setKeys(keys);
    }

    @Override
    protected Node[] createNodes(DesignGraphSlot slot) {
        return new Node[]{new SlotNode(slot)};
    }
}
