/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.gpdv.core.implementation.scenes;

import org.gpdv.services.GraphRouter;
import java.awt.Point;
import java.util.List;
import org.netbeans.api.visual.router.Router;
import org.netbeans.api.visual.router.RouterFactory;
import org.netbeans.api.visual.widget.ConnectionWidget;
import org.netbeans.api.visual.widget.LayerWidget;
import org.openide.nodes.AbstractNode;
import org.openide.nodes.Children;
import org.openide.nodes.Node;

/**
 *
 * @author odi
 */
public class DirectWrapper implements GraphRouter{

    private final String NAME = "DIRECTROUTER";
    private final String DISPLAYNAME = "Direct router";
    private final String DESCRIPTION = "Router that uses direct connections only";

    @Override
    public Node getRepresentation(){
        AbstractNode n = new AbstractNode(Children.LEAF);
        n.setName(NAME);
        n.setDisplayName(DISPLAYNAME);
        n.setShortDescription(DESCRIPTION);
        return n;
    }

    private Router directRouter;

    public void setLayerWidget(LayerWidget widget) {
    }

    public List<Point> routeConnection(ConnectionWidget widget) {
        if(directRouter == null) directRouter = RouterFactory.createDirectRouter();
        return directRouter.routeConnection(widget);
    }

}
