/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.gpdv.core.implementation.scenes;

import org.gpdv.services.GraphRouter;
import java.awt.Point;
import java.util.ArrayList;
import java.util.List;
import org.netbeans.api.visual.router.Router;
import org.netbeans.api.visual.router.RouterFactory;
import org.netbeans.api.visual.widget.ConnectionWidget;
import org.netbeans.api.visual.widget.LayerWidget;
import org.openide.nodes.AbstractNode;
import org.openide.nodes.Children;
import org.openide.nodes.Node;

/**
 *
 * @author odi
 */
public class OrthogonalWrapper implements GraphRouter{

    private final String NAME = "ORTHOGONALROUTER";
    private final String DISPLAYNAME = "Orthogonal router";
    private final String DESCRIPTION = "Router that uses orthogonal connections only";

    @Override
    public Node getRepresentation(){
        AbstractNode n = new AbstractNode(Children.LEAF);
        n.setName(NAME);
        n.setDisplayName(DISPLAYNAME);
        n.setShortDescription(DESCRIPTION);
        return n;
    }

    private Router router;
    
    public void setLayerWidget(LayerWidget widget){
        router = RouterFactory.createOrthogonalSearchRouter(widget);
    }

    public List<Point> routeConnection(ConnectionWidget widget) {
        return router.routeConnection(widget);
    }
}
