/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.gpdv.core.implementation.scenes;

import org.gpdv.services.GraphRouter;
import java.awt.Point;
import java.util.ArrayList;
import java.util.List;
import org.netbeans.api.visual.router.Router;
import org.netbeans.api.visual.widget.ConnectionWidget;
import org.netbeans.api.visual.widget.LayerWidget;
import org.openide.nodes.AbstractNode;
import org.openide.nodes.Children;
import org.openide.nodes.Node;

/**
 *
 * @author odi
 */
public class TestRouter implements GraphRouter {

    private final String NAME = "VERTICALSTARTROUTER";
    private final String DISPLAYNAME = "Vertical start router";
    private final String DESCRIPTION = "Router that starts all connections in vertical direction";

    @Override
    public Node getRepresentation(){
        AbstractNode n = new AbstractNode(Children.LEAF);
        n.setName(NAME);
        n.setDisplayName(DISPLAYNAME);
        n.setShortDescription(DESCRIPTION);
        return n;
    }

    public void setLayerWidget(LayerWidget widget){

    }

    public List<Point> routeConnection(ConnectionWidget widget) {
        Point start = widget.getSourceAnchor().compute(widget.getSourceAnchorEntry()).getAnchorSceneLocation();
        Point end = widget.getTargetAnchor().compute(widget.getTargetAnchorEntry()).getAnchorSceneLocation();
        List<Point> p = new ArrayList<Point>();
        p.add(start);
        Point p1;
        if(start.y<end.y){
            p1 = new Point(start.x, Math.min(start.y+30, end.y));
            p.add(p1);
        } else {
            p1 = new Point(start.x, Math.max(start.y-30, end.y));
            p.add(p1);
        }
        p.add(end);
        return p;
    }

}
